{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# HW 2 Part 1\n",
    "\n",
    "By: Chengyi (Jeff) Chen"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "/opt/anaconda3/envs/ml/lib/python3.7/site-packages/statsmodels/tools/_testing.py:19: FutureWarning: pandas.util.testing is deprecated. Use the functions in the public API at pandas.testing instead.\n",
      "  import pandas.util.testing as tm\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 1;\n",
       "                var nbb_unformatted_code = \"%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom collections import namedtuple\\nfrom statsmodels.graphics.gofplots import qqplot\\nfrom datetime import datetime, timedelta\\nfrom tqdm import tqdm\";\n",
       "                var nbb_formatted_code = \"%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom collections import namedtuple\\nfrom statsmodels.graphics.gofplots import qqplot\\nfrom datetime import datetime, timedelta\\nfrom tqdm import tqdm\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%load_ext nb_black\n",
    "%matplotlib inline\n",
    "\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "plt.rcParams[\"figure.dpi\"] = 300\n",
    "plt.rcParams[\"figure.figsize\"] = (16, 12)\n",
    "\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "import cvxpy as cp\n",
    "import scipy as sp\n",
    "from collections import namedtuple\n",
    "from statsmodels.graphics.gofplots import qqplot\n",
    "from datetime import datetime, timedelta\n",
    "from tqdm import tqdm"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### SPY and US Dollar Index Monthly Returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>S&amp;P - 500 Index</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-0.984416</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-6.260163</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-8.075231</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>1.906875</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>7.670629</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            S&P - 500 Index\n",
       "2001-07-31        -0.984416\n",
       "2001-08-31        -6.260163\n",
       "2001-09-30        -8.075231\n",
       "2001-10-31         1.906875\n",
       "2001-11-30         7.670629"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 2;\n",
       "                var nbb_unformatted_code = \"spy_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\\n)\\nspy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\\nspy_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"spy_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\\n)\\nspy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\\nspy_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "spy_monthly_returns = pd.read_excel(\n",
    "    \"./data/HW2.xlsx\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\n",
    ")\n",
    "spy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\n",
    "spy_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>US Dollar Index</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-1.916799</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-3.208739</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-0.008817</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>1.278547</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>1.105694</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            US Dollar Index\n",
       "2001-07-31        -1.916799\n",
       "2001-08-31        -3.208739\n",
       "2001-09-30        -0.008817\n",
       "2001-10-31         1.278547\n",
       "2001-11-30         1.105694"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 3;\n",
       "                var nbb_unformatted_code = \"us_dollar_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\\n)\\nus_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\\nus_dollar_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"us_dollar_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\\n)\\nus_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\\nus_dollar_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "us_dollar_monthly_returns = pd.read_excel(\n",
    "    \"./data/HW2.xlsx\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\n",
    ")\n",
    "us_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\n",
    "us_dollar_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### S&P 500 Equities Monthly Returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead tr th {\n",
       "        text-align: left;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr>\n",
       "      <th>NAME</th>\n",
       "      <th>3m Co</th>\n",
       "      <th>Abbott Labs</th>\n",
       "      <th>Abbvie Inc</th>\n",
       "      <th>Abiomed Inc</th>\n",
       "      <th>Accenture Plc Ireland</th>\n",
       "      <th>Activision Blizzard Inc</th>\n",
       "      <th>Adobe Sys Inc</th>\n",
       "      <th>Advance Auto Parts</th>\n",
       "      <th>Advanced Micro Devic</th>\n",
       "      <th>Aes Corp</th>\n",
       "      <th>...</th>\n",
       "      <th>Willis Towers Watson Pu</th>\n",
       "      <th>Wynn Resorts Ltd</th>\n",
       "      <th>Xcel Energy Inc</th>\n",
       "      <th>Xerox Corp</th>\n",
       "      <th>Xilinx Inc</th>\n",
       "      <th>Xylem Inc</th>\n",
       "      <th>Yum Brands Inc</th>\n",
       "      <th>Zimmer Hldgs Inc</th>\n",
       "      <th>Zions Bancorp</th>\n",
       "      <th>Zoetis Inc</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>TICKER</th>\n",
       "      <th>MMM</th>\n",
       "      <th>ABT</th>\n",
       "      <th>ABBV</th>\n",
       "      <th>ABMD</th>\n",
       "      <th>ACN</th>\n",
       "      <th>ATVI</th>\n",
       "      <th>ADBE</th>\n",
       "      <th>AAP</th>\n",
       "      <th>AMD</th>\n",
       "      <th>AES</th>\n",
       "      <th>...</th>\n",
       "      <th>WLTW</th>\n",
       "      <th>WYNN</th>\n",
       "      <th>XEL</th>\n",
       "      <th>XRX</th>\n",
       "      <th>XLNX</th>\n",
       "      <th>XYL</th>\n",
       "      <th>YUM</th>\n",
       "      <th>ZBH</th>\n",
       "      <th>ZION</th>\n",
       "      <th>ZTS</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR</th>\n",
       "      <th>INDU</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>INFT</th>\n",
       "      <th>TCOM</th>\n",
       "      <th>INFT</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>INFT</th>\n",
       "      <th>UTIL</th>\n",
       "      <th>...</th>\n",
       "      <th>FINA</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>UTIL</th>\n",
       "      <th>INFT</th>\n",
       "      <th>INFT</th>\n",
       "      <th>INDU</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>FINA</th>\n",
       "      <th>HLTH</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Market Cap ($ Mil)</th>\n",
       "      <th>110949</th>\n",
       "      <th>127036</th>\n",
       "      <th>138674</th>\n",
       "      <th>14640</th>\n",
       "      <th>89887</th>\n",
       "      <th>35535</th>\n",
       "      <th>110435</th>\n",
       "      <th>11478</th>\n",
       "      <th>18449</th>\n",
       "      <th>9577</th>\n",
       "      <th>...</th>\n",
       "      <th>19733</th>\n",
       "      <th>10755</th>\n",
       "      <th>25326</th>\n",
       "      <th>4708</th>\n",
       "      <th>21552</th>\n",
       "      <th>11991</th>\n",
       "      <th>28707</th>\n",
       "      <th>21156</th>\n",
       "      <th>7830</th>\n",
       "      <th>41098</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-1.945100</td>\n",
       "      <td>12.112976</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-19.423240</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-13.577718</td>\n",
       "      <td>-20.234087</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-36.816609</td>\n",
       "      <td>-11.033682</td>\n",
       "      <td>...</td>\n",
       "      <td>-2.816904</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-4.077114</td>\n",
       "      <td>-16.614480</td>\n",
       "      <td>-3.006790</td>\n",
       "      <td>NaN</td>\n",
       "      <td>4.214608</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-0.932129</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-6.446533</td>\n",
       "      <td>-7.258951</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-1.315789</td>\n",
       "      <td>-0.401070</td>\n",
       "      <td>9.226306</td>\n",
       "      <td>-10.349165</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-25.794085</td>\n",
       "      <td>-13.524804</td>\n",
       "      <td>...</td>\n",
       "      <td>9.043619</td>\n",
       "      <td>NaN</td>\n",
       "      <td>1.707327</td>\n",
       "      <td>15.288163</td>\n",
       "      <td>-2.400000</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.842003</td>\n",
       "      <td>-4.895105</td>\n",
       "      <td>-1.698511</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-5.475902</td>\n",
       "      <td>4.326061</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.826667</td>\n",
       "      <td>-14.429530</td>\n",
       "      <td>-26.532794</td>\n",
       "      <td>-28.616782</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-39.852399</td>\n",
       "      <td>-61.292271</td>\n",
       "      <td>...</td>\n",
       "      <td>24.348706</td>\n",
       "      <td>NaN</td>\n",
       "      <td>4.106134</td>\n",
       "      <td>-15.760939</td>\n",
       "      <td>-39.728484</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-7.977550</td>\n",
       "      <td>2.022059</td>\n",
       "      <td>-6.287271</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>6.077282</td>\n",
       "      <td>2.599966</td>\n",
       "      <td>NaN</td>\n",
       "      <td>24.441900</td>\n",
       "      <td>37.803922</td>\n",
       "      <td>32.808711</td>\n",
       "      <td>10.091781</td>\n",
       "      <td>NaN</td>\n",
       "      <td>20.736196</td>\n",
       "      <td>8.034321</td>\n",
       "      <td>...</td>\n",
       "      <td>-0.427533</td>\n",
       "      <td>NaN</td>\n",
       "      <td>0.461629</td>\n",
       "      <td>-9.677419</td>\n",
       "      <td>29.281768</td>\n",
       "      <td>NaN</td>\n",
       "      <td>28.990256</td>\n",
       "      <td>11.387387</td>\n",
       "      <td>-10.696854</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>10.339559</td>\n",
       "      <td>3.812730</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-12.741490</td>\n",
       "      <td>28.628344</td>\n",
       "      <td>3.113693</td>\n",
       "      <td>21.515301</td>\n",
       "      <td>NaN</td>\n",
       "      <td>37.804878</td>\n",
       "      <td>19.277978</td>\n",
       "      <td>...</td>\n",
       "      <td>1.674522</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-3.429815</td>\n",
       "      <td>20.000215</td>\n",
       "      <td>18.704799</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.206153</td>\n",
       "      <td>4.367519</td>\n",
       "      <td>1.164570</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>5 rows × 505 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "NAME                    3m Co Abbott Labs Abbvie Inc Abiomed Inc  \\\n",
       "TICKER                    MMM         ABT       ABBV        ABMD   \n",
       "SECTOR                   INDU        HLTH       HLTH        HLTH   \n",
       "Market Cap ($ Mil)     110949      127036     138674      14640    \n",
       "2001-07-31          -1.945100   12.112976        NaN  -19.423240   \n",
       "2001-08-31          -6.446533   -7.258951        NaN   -1.315789   \n",
       "2001-09-30          -5.475902    4.326061        NaN   -6.826667   \n",
       "2001-10-31           6.077282    2.599966        NaN   24.441900   \n",
       "2001-11-30          10.339559    3.812730        NaN  -12.741490   \n",
       "\n",
       "NAME               Accenture Plc Ireland Activision Blizzard Inc  \\\n",
       "TICKER                               ACN                    ATVI   \n",
       "SECTOR                              INFT                    TCOM   \n",
       "Market Cap ($ Mil)                89887                   35535    \n",
       "2001-07-31                           NaN              -13.577718   \n",
       "2001-08-31                     -0.401070                9.226306   \n",
       "2001-09-30                    -14.429530              -26.532794   \n",
       "2001-10-31                     37.803922               32.808711   \n",
       "2001-11-30                     28.628344                3.113693   \n",
       "\n",
       "NAME               Adobe Sys Inc Advance Auto Parts Advanced Micro Devic  \\\n",
       "TICKER                      ADBE                AAP                  AMD   \n",
       "SECTOR                      INFT               DSCR                 INFT   \n",
       "Market Cap ($ Mil)        110435             11478                18449    \n",
       "2001-07-31            -20.234087                NaN           -36.816609   \n",
       "2001-08-31            -10.349165                NaN           -25.794085   \n",
       "2001-09-30            -28.616782                NaN           -39.852399   \n",
       "2001-10-31             10.091781                NaN            20.736196   \n",
       "2001-11-30             21.515301                NaN            37.804878   \n",
       "\n",
       "NAME                 Aes Corp  ... Willis Towers Watson Pu Wynn Resorts Ltd  \\\n",
       "TICKER                    AES  ...                    WLTW             WYNN   \n",
       "SECTOR                   UTIL  ...                    FINA             DSCR   \n",
       "Market Cap ($ Mil)     9577    ...                  19733            10755    \n",
       "2001-07-31         -11.033682  ...               -2.816904              NaN   \n",
       "2001-08-31         -13.524804  ...                9.043619              NaN   \n",
       "2001-09-30         -61.292271  ...               24.348706              NaN   \n",
       "2001-10-31           8.034321  ...               -0.427533              NaN   \n",
       "2001-11-30          19.277978  ...                1.674522              NaN   \n",
       "\n",
       "NAME               Xcel Energy Inc Xerox Corp Xilinx Inc Xylem Inc  \\\n",
       "TICKER                         XEL        XRX       XLNX       XYL   \n",
       "SECTOR                        UTIL       INFT       INFT      INDU   \n",
       "Market Cap ($ Mil)          25326      4708       21552     11991    \n",
       "2001-07-31               -4.077114 -16.614480  -3.006790       NaN   \n",
       "2001-08-31                1.707327  15.288163  -2.400000       NaN   \n",
       "2001-09-30                4.106134 -15.760939 -39.728484       NaN   \n",
       "2001-10-31                0.461629  -9.677419  29.281768       NaN   \n",
       "2001-11-30               -3.429815  20.000215  18.704799       NaN   \n",
       "\n",
       "NAME               Yum Brands Inc Zimmer Hldgs Inc Zions Bancorp Zoetis Inc  \n",
       "TICKER                        YUM              ZBH          ZION        ZTS  \n",
       "SECTOR                       DSCR             HLTH          FINA       HLTH  \n",
       "Market Cap ($ Mil)         28707            21156         7830       41098   \n",
       "2001-07-31               4.214608              NaN     -0.932129        NaN  \n",
       "2001-08-31              -6.842003        -4.895105     -1.698511        NaN  \n",
       "2001-09-30              -7.977550         2.022059     -6.287271        NaN  \n",
       "2001-10-31              28.990256        11.387387    -10.696854        NaN  \n",
       "2001-11-30              -6.206153         4.367519      1.164570        NaN  \n",
       "\n",
       "[5 rows x 505 columns]"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 4;\n",
       "                var nbb_unformatted_code = \"equity_monthly_returns = (\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1]).iloc[:, 4:].T\\n)\\nequity_monthly_returns.columns = pd.MultiIndex.from_frame(\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\\n)\\nequity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\\nequity_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"equity_monthly_returns = (\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1]).iloc[:, 4:].T\\n)\\nequity_monthly_returns.columns = pd.MultiIndex.from_frame(\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\\n)\\nequity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\\nequity_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "equity_monthly_returns = (\n",
    "    pd.read_excel(\"./data/HW2.xlsx\", sheet_name=1, header=[1]).iloc[:, 4:].T\n",
    ")\n",
    "equity_monthly_returns.columns = pd.MultiIndex.from_frame(\n",
    "    pd.read_excel(\"./data/HW2.xlsx\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\n",
    ")\n",
    "equity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\n",
    "equity_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## A - Calculate historical factor monthly returns for the following factors based on Arbitrage Pricing Theory\n",
    "\n",
    "1. Equity market factor. Using SP500 index return as equity market return proxy. (Data see SPX_DXY_MonthlyReturns)\n",
    "2. US Dollar factor. Using  DXY Index returns as proxy. (Data see SPX_DXY_MonthlyReturns)\n",
    "3. Sector factors. (Note: you should leave one sector out to make sure proper running of Fama Macbeth regression. Let's leave out the sector of UTIL.)\n",
    "4. Size factor. At each month-end reconstitution date, we use the same company market cap data (column D on SP500Stocks) for simplicity. (Note: size exposure for a company should be sector neutral, i.e., the z-score of the log(mkt_cap) should be w.r.t. peer companies within the same sector.)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "OLS Closed Form Solution:\n",
    "\\begin{align}\n",
    "    \\hat\\beta &= (X^TX)^{-1}X^Ty\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 5;\n",
       "                var nbb_unformatted_code = \"intersect = lambda a, b: sorted(set(a) & set(b))\\n\\n\\ndef \\u03b2_hat(X, y, dropna=True):\\n    if dropna:\\n        X, y = X.dropna(), y.dropna()\\n        common_index = intersect(X.index, y.index)\\n        X, y = X.loc[common_index], y.loc[common_index]\\n    else:\\n        X, y = X.fillna(0.0), y.fillna(0.0)\\n    return (\\n        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\\n        @ X.T\\n        @ y.values\\n    )\";\n",
       "                var nbb_formatted_code = \"intersect = lambda a, b: sorted(set(a) & set(b))\\n\\n\\ndef \\u03b2_hat(X, y, dropna=True):\\n    if dropna:\\n        X, y = X.dropna(), y.dropna()\\n        common_index = intersect(X.index, y.index)\\n        X, y = X.loc[common_index], y.loc[common_index]\\n    else:\\n        X, y = X.fillna(0.0), y.fillna(0.0)\\n    return (\\n        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\\n        @ X.T\\n        @ y.values\\n    )\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "intersect = lambda a, b: sorted(set(a) & set(b))\n",
    "\n",
    "\n",
    "def β_hat(X, y, dropna=True):\n",
    "    if dropna:\n",
    "        X, y = X.dropna(), y.dropna()\n",
    "        common_index = intersect(X.index, y.index)\n",
    "        X, y = X.loc[common_index], y.loc[common_index]\n",
    "    else:\n",
    "        X, y = X.fillna(0.0), y.fillna(0.0)\n",
    "    return (\n",
    "        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\n",
    "        @ X.T\n",
    "        @ y.values\n",
    "    )"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## [Fama-Macbeth Two-step Regression](http://didattica.unibocconi.it/mypage/dwload.php?nomefile=fama-macbeth20141115121157.pdf)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Step 1 - Regress the Time Series of Returns of the Stock against Time Series of Factors to get Factor Exposures $\\beta_{\\text{factor}}$\n",
    "\n",
    "For $m$ factors:\n",
    "\n",
    "\\begin{align}\n",
    "    R_{\\text{Stock A}} &= \\alpha + \\beta_{F_1}F_1 + \\beta_{F_2}F_2 + \\cdots + \\beta_{F_m}F_m + \\epsilon\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Factor Exposures of each stock to S&P 500 and US Dollar"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>β (equity market factor exposure)</th>\n",
       "      <th>β (us dollar factor exposure)</th>\n",
       "      <th>α</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>NAME</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>3m Co</th>\n",
       "      <td>0.897279</td>\n",
       "      <td>0.137059</td>\n",
       "      <td>0.411085</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbott Labs</th>\n",
       "      <td>0.501031</td>\n",
       "      <td>-0.096830</td>\n",
       "      <td>0.635259</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbvie Inc</th>\n",
       "      <td>1.450096</td>\n",
       "      <td>-0.556901</td>\n",
       "      <td>0.662926</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abiomed Inc</th>\n",
       "      <td>1.263956</td>\n",
       "      <td>0.059849</td>\n",
       "      <td>1.770226</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Accenture Plc Ireland</th>\n",
       "      <td>1.152855</td>\n",
       "      <td>0.193686</td>\n",
       "      <td>0.772685</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "                       β (equity market factor exposure)  \\\n",
       "NAME                                                       \n",
       "3m Co                                           0.897279   \n",
       "Abbott Labs                                     0.501031   \n",
       "Abbvie Inc                                      1.450096   \n",
       "Abiomed Inc                                     1.263956   \n",
       "Accenture Plc Ireland                           1.152855   \n",
       "\n",
       "                       β (us dollar factor exposure)         α  \n",
       "NAME                                                            \n",
       "3m Co                                       0.137059  0.411085  \n",
       "Abbott Labs                                -0.096830  0.635259  \n",
       "Abbvie Inc                                 -0.556901  0.662926  \n",
       "Abiomed Inc                                 0.059849  1.770226  \n",
       "Accenture Plc Ireland                       0.193686  0.772685  "
      ]
     },
     "execution_count": 6,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 6;\n",
       "                var nbb_unformatted_code = \"factor_exposures = equity_monthly_returns.apply(\\n    lambda equity: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                spy_monthly_returns,\\n                us_dollar_monthly_returns,\\n                pd.Series(1, name=\\\"\\u03b1\\\", index=spy_monthly_returns.index),\\n            ],\\n            axis=1,\\n        ),\\n        y=equity,\\n        dropna=True,\\n    ),\\n    axis=0,\\n).T\\nfactor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\\nfactor_exposures.rename(\\n    {\\n        \\\"S&P - 500 Index\\\": \\\"\\u03b2 (equity market factor exposure)\\\",\\n        \\\"US Dollar Index\\\": \\\"\\u03b2 (us dollar factor exposure)\\\",\\n    },\\n    axis=1,\\n    inplace=True,\\n)\\nfactor_exposures.head()\";\n",
       "                var nbb_formatted_code = \"factor_exposures = equity_monthly_returns.apply(\\n    lambda equity: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                spy_monthly_returns,\\n                us_dollar_monthly_returns,\\n                pd.Series(1, name=\\\"\\u03b1\\\", index=spy_monthly_returns.index),\\n            ],\\n            axis=1,\\n        ),\\n        y=equity,\\n        dropna=True,\\n    ),\\n    axis=0,\\n).T\\nfactor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\\nfactor_exposures.rename(\\n    {\\n        \\\"S&P - 500 Index\\\": \\\"\\u03b2 (equity market factor exposure)\\\",\\n        \\\"US Dollar Index\\\": \\\"\\u03b2 (us dollar factor exposure)\\\",\\n    },\\n    axis=1,\\n    inplace=True,\\n)\\nfactor_exposures.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "factor_exposures = equity_monthly_returns.apply(\n",
    "    lambda equity: β_hat(\n",
    "        X=pd.concat(\n",
    "            [\n",
    "                spy_monthly_returns,\n",
    "                us_dollar_monthly_returns,\n",
    "                pd.Series(1, name=\"α\", index=spy_monthly_returns.index),\n",
    "            ],\n",
    "            axis=1,\n",
    "        ),\n",
    "        y=equity,\n",
    "        dropna=True,\n",
    "    ),\n",
    "    axis=0,\n",
    ").T\n",
    "factor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\n",
    "factor_exposures.rename(\n",
    "    {\n",
    "        \"S&P - 500 Index\": \"β (equity market factor exposure)\",\n",
    "        \"US Dollar Index\": \"β (us dollar factor exposure)\",\n",
    "    },\n",
    "    axis=1,\n",
    "    inplace=True,\n",
    ")\n",
    "factor_exposures.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Sector factor one-hot encoding, drop UTIL sector column"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>SECTOR_DSCR</th>\n",
       "      <th>SECTOR_ENER</th>\n",
       "      <th>SECTOR_FINA</th>\n",
       "      <th>SECTOR_HLTH</th>\n",
       "      <th>SECTOR_INDU</th>\n",
       "      <th>SECTOR_INFT</th>\n",
       "      <th>SECTOR_MATS</th>\n",
       "      <th>SECTOR_REAL</th>\n",
       "      <th>SECTOR_STPL</th>\n",
       "      <th>SECTOR_TCOM</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>NAME</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>3m Co</th>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>1</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbott Labs</th>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>1</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbvie Inc</th>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>1</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abiomed Inc</th>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>1</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Accenture Plc Ireland</th>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>1</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "      <td>0</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "                       SECTOR_DSCR  SECTOR_ENER  SECTOR_FINA  SECTOR_HLTH  \\\n",
       "NAME                                                                        \n",
       "3m Co                            0            0            0            0   \n",
       "Abbott Labs                      0            0            0            1   \n",
       "Abbvie Inc                       0            0            0            1   \n",
       "Abiomed Inc                      0            0            0            1   \n",
       "Accenture Plc Ireland            0            0            0            0   \n",
       "\n",
       "                       SECTOR_INDU  SECTOR_INFT  SECTOR_MATS  SECTOR_REAL  \\\n",
       "NAME                                                                        \n",
       "3m Co                            1            0            0            0   \n",
       "Abbott Labs                      0            0            0            0   \n",
       "Abbvie Inc                       0            0            0            0   \n",
       "Abiomed Inc                      0            0            0            0   \n",
       "Accenture Plc Ireland            0            1            0            0   \n",
       "\n",
       "                       SECTOR_STPL  SECTOR_TCOM  \n",
       "NAME                                             \n",
       "3m Co                            0            0  \n",
       "Abbott Labs                      0            0  \n",
       "Abbvie Inc                       0            0  \n",
       "Abiomed Inc                      0            0  \n",
       "Accenture Plc Ireland            0            0  "
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 7;\n",
       "                var nbb_unformatted_code = \"sector_factor = pd.concat(\\n    [\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n    ],\\n    axis=1,\\n)\\nsector_factor.set_index(\\\"NAME\\\", inplace=True)\\nsector_factor = pd.get_dummies(sector_factor).drop([\\\"SECTOR_UTIL\\\"], axis=1)\\nsector_factor.head()\";\n",
       "                var nbb_formatted_code = \"sector_factor = pd.concat(\\n    [\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n    ],\\n    axis=1,\\n)\\nsector_factor.set_index(\\\"NAME\\\", inplace=True)\\nsector_factor = pd.get_dummies(sector_factor).drop([\\\"SECTOR_UTIL\\\"], axis=1)\\nsector_factor.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "sector_factor = pd.concat(\n",
    "    [\n",
    "        pd.Series(equity_monthly_returns.columns.get_level_values(\"NAME\")),\n",
    "        pd.Series(equity_monthly_returns.columns.get_level_values(\"SECTOR\")),\n",
    "    ],\n",
    "    axis=1,\n",
    ")\n",
    "sector_factor.set_index(\"NAME\", inplace=True)\n",
    "sector_factor = pd.get_dummies(sector_factor).drop([\"SECTOR_UTIL\"], axis=1)\n",
    "sector_factor.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Size factor - Standardize log(Market Cap) by sector"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>β (size factor exposure)</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>NAME</th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>3m Co</th>\n",
       "      <td>1.977538</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbott Labs</th>\n",
       "      <td>1.350510</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abbvie Inc</th>\n",
       "      <td>1.436935</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Abiomed Inc</th>\n",
       "      <td>-0.779869</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Accenture Plc Ireland</th>\n",
       "      <td>1.038986</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "                       β (size factor exposure)\n",
       "NAME                                           \n",
       "3m Co                                  1.977538\n",
       "Abbott Labs                            1.350510\n",
       "Abbvie Inc                             1.436935\n",
       "Abiomed Inc                           -0.779869\n",
       "Accenture Plc Ireland                  1.038986"
      ]
     },
     "execution_count": 8,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 8;\n",
       "                var nbb_unformatted_code = \"size_factor = (\\n    pd.concat(\\n        [\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n            pd.Series(\\n                equity_monthly_returns.columns.get_level_values(\\\"Market Cap ($ Mil)\\\")\\n            ),\\n        ],\\n        axis=1,\\n    )\\n    .groupby(\\\"SECTOR\\\")[\\\"Market Cap ($ Mil)\\\"]\\n    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\\n    .to_frame()\\n)\\nsize_factor.index = equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")\\nsize_factor.rename(\\n    {\\\"Market Cap ($ Mil)\\\": \\\"\\u03b2 (size factor exposure)\\\"}, axis=1, inplace=True\\n)\\nsize_factor.head()\";\n",
       "                var nbb_formatted_code = \"size_factor = (\\n    pd.concat(\\n        [\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n            pd.Series(\\n                equity_monthly_returns.columns.get_level_values(\\\"Market Cap ($ Mil)\\\")\\n            ),\\n        ],\\n        axis=1,\\n    )\\n    .groupby(\\\"SECTOR\\\")[\\\"Market Cap ($ Mil)\\\"]\\n    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\\n    .to_frame()\\n)\\nsize_factor.index = equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")\\nsize_factor.rename(\\n    {\\\"Market Cap ($ Mil)\\\": \\\"\\u03b2 (size factor exposure)\\\"}, axis=1, inplace=True\\n)\\nsize_factor.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "size_factor = (\n",
    "    pd.concat(\n",
    "        [\n",
    "            pd.Series(equity_monthly_returns.columns.get_level_values(\"NAME\")),\n",
    "            pd.Series(equity_monthly_returns.columns.get_level_values(\"SECTOR\")),\n",
    "            pd.Series(\n",
    "                equity_monthly_returns.columns.get_level_values(\"Market Cap ($ Mil)\")\n",
    "            ),\n",
    "        ],\n",
    "        axis=1,\n",
    "    )\n",
    "    .groupby(\"SECTOR\")[\"Market Cap ($ Mil)\"]\n",
    "    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\n",
    "    .to_frame()\n",
    ")\n",
    "size_factor.index = equity_monthly_returns.columns.get_level_values(\"NAME\")\n",
    "size_factor.rename(\n",
    "    {\"Market Cap ($ Mil)\": \"β (size factor exposure)\"}, axis=1, inplace=True\n",
    ")\n",
    "size_factor.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Step 2 - Regress Returns of all the Stock in the Portfolio @ time $t, t \\in T$ against Factor Exposures $\\beta_{\\text{factor}}$ of each Stock\n",
    "\n",
    "For $t \\in T$ timesteps:\n",
    "\n",
    "\\begin{align}\n",
    "    R_{\\text{Stock }i, t} &= \\gamma_{t, F_0} + \\gamma_{t, F_1}\\hat{\\beta_{F_1}} + \\gamma_{t, F_2}\\hat{\\beta_{F_2}} + \\cdots + \\gamma_{t, F_m}\\hat{\\beta_{F_m}} + \\epsilon\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {
    "scrolled": true
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>β (equity market factor exposure)</th>\n",
       "      <th>β (us dollar factor exposure)</th>\n",
       "      <th>SECTOR_DSCR</th>\n",
       "      <th>SECTOR_ENER</th>\n",
       "      <th>SECTOR_FINA</th>\n",
       "      <th>SECTOR_HLTH</th>\n",
       "      <th>SECTOR_INDU</th>\n",
       "      <th>SECTOR_INFT</th>\n",
       "      <th>SECTOR_MATS</th>\n",
       "      <th>SECTOR_REAL</th>\n",
       "      <th>SECTOR_STPL</th>\n",
       "      <th>SECTOR_TCOM</th>\n",
       "      <th>β (size factor exposure)</th>\n",
       "      <th>γ_residual</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-5.081906</td>\n",
       "      <td>0.546521</td>\n",
       "      <td>9.689164</td>\n",
       "      <td>4.497985</td>\n",
       "      <td>6.003830</td>\n",
       "      <td>3.868261</td>\n",
       "      <td>7.997561</td>\n",
       "      <td>5.971431</td>\n",
       "      <td>7.795002</td>\n",
       "      <td>3.298414</td>\n",
       "      <td>5.834931</td>\n",
       "      <td>4.522445</td>\n",
       "      <td>-0.666501</td>\n",
       "      <td>-0.172946</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-5.351213</td>\n",
       "      <td>-2.530621</td>\n",
       "      <td>-0.865683</td>\n",
       "      <td>-1.974351</td>\n",
       "      <td>-0.172676</td>\n",
       "      <td>0.152704</td>\n",
       "      <td>0.283117</td>\n",
       "      <td>-0.786473</td>\n",
       "      <td>2.069103</td>\n",
       "      <td>2.237107</td>\n",
       "      <td>0.399686</td>\n",
       "      <td>-0.210663</td>\n",
       "      <td>-0.887846</td>\n",
       "      <td>3.563947</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-16.448408</td>\n",
       "      <td>-4.242000</td>\n",
       "      <td>6.115425</td>\n",
       "      <td>5.129572</td>\n",
       "      <td>15.719172</td>\n",
       "      <td>7.981975</td>\n",
       "      <td>9.199334</td>\n",
       "      <td>8.180248</td>\n",
       "      <td>9.807025</td>\n",
       "      <td>11.983056</td>\n",
       "      <td>5.616929</td>\n",
       "      <td>8.494224</td>\n",
       "      <td>-0.404314</td>\n",
       "      <td>0.634008</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>7.730491</td>\n",
       "      <td>4.661245</td>\n",
       "      <td>-0.237472</td>\n",
       "      <td>5.161065</td>\n",
       "      <td>-8.600545</td>\n",
       "      <td>2.401637</td>\n",
       "      <td>-3.667805</td>\n",
       "      <td>5.580222</td>\n",
       "      <td>-2.020707</td>\n",
       "      <td>-6.257782</td>\n",
       "      <td>-0.408720</td>\n",
       "      <td>0.168053</td>\n",
       "      <td>-0.612423</td>\n",
       "      <td>-2.110206</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>9.140003</td>\n",
       "      <td>4.696506</td>\n",
       "      <td>3.084856</td>\n",
       "      <td>-7.999442</td>\n",
       "      <td>-0.934668</td>\n",
       "      <td>0.446165</td>\n",
       "      <td>1.300240</td>\n",
       "      <td>2.209795</td>\n",
       "      <td>3.643307</td>\n",
       "      <td>-0.218926</td>\n",
       "      <td>2.664973</td>\n",
       "      <td>-1.297612</td>\n",
       "      <td>1.092705</td>\n",
       "      <td>-3.667960</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            β (equity market factor exposure)  β (us dollar factor exposure)  \\\n",
       "2001-07-31                          -5.081906                       0.546521   \n",
       "2001-08-31                          -5.351213                      -2.530621   \n",
       "2001-09-30                         -16.448408                      -4.242000   \n",
       "2001-10-31                           7.730491                       4.661245   \n",
       "2001-11-30                           9.140003                       4.696506   \n",
       "\n",
       "            SECTOR_DSCR  SECTOR_ENER  SECTOR_FINA  SECTOR_HLTH  SECTOR_INDU  \\\n",
       "2001-07-31     9.689164     4.497985     6.003830     3.868261     7.997561   \n",
       "2001-08-31    -0.865683    -1.974351    -0.172676     0.152704     0.283117   \n",
       "2001-09-30     6.115425     5.129572    15.719172     7.981975     9.199334   \n",
       "2001-10-31    -0.237472     5.161065    -8.600545     2.401637    -3.667805   \n",
       "2001-11-30     3.084856    -7.999442    -0.934668     0.446165     1.300240   \n",
       "\n",
       "            SECTOR_INFT  SECTOR_MATS  SECTOR_REAL  SECTOR_STPL  SECTOR_TCOM  \\\n",
       "2001-07-31     5.971431     7.795002     3.298414     5.834931     4.522445   \n",
       "2001-08-31    -0.786473     2.069103     2.237107     0.399686    -0.210663   \n",
       "2001-09-30     8.180248     9.807025    11.983056     5.616929     8.494224   \n",
       "2001-10-31     5.580222    -2.020707    -6.257782    -0.408720     0.168053   \n",
       "2001-11-30     2.209795     3.643307    -0.218926     2.664973    -1.297612   \n",
       "\n",
       "            β (size factor exposure)  γ_residual  \n",
       "2001-07-31                 -0.666501   -0.172946  \n",
       "2001-08-31                 -0.887846    3.563947  \n",
       "2001-09-30                 -0.404314    0.634008  \n",
       "2001-10-31                 -0.612423   -2.110206  \n",
       "2001-11-30                  1.092705   -3.667960  "
      ]
     },
     "execution_count": 9,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 9;\n",
       "                var nbb_unformatted_code = \"\\u03b3_pure_factor_monthly_returns = equity_monthly_returns.apply(\\n    lambda returns: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n                sector_factor,\\n                size_factor,\\n                pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n            ],\\n            axis=1,\\n        ),\\n        y=returns,\\n        dropna=False,\\n    ),\\n    axis=1,\\n)\\n\\u03b3_pure_factor_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"\\u03b3_pure_factor_monthly_returns = equity_monthly_returns.apply(\\n    lambda returns: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n                sector_factor,\\n                size_factor,\\n                pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n            ],\\n            axis=1,\\n        ),\\n        y=returns,\\n        dropna=False,\\n    ),\\n    axis=1,\\n)\\n\\u03b3_pure_factor_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "γ_pure_factor_monthly_returns = equity_monthly_returns.apply(\n",
    "    lambda returns: β_hat(\n",
    "        X=pd.concat(\n",
    "            [\n",
    "                factor_exposures.drop([\"α\"], axis=1),\n",
    "                sector_factor,\n",
    "                size_factor,\n",
    "                pd.Series(1, index=size_factor.index, name=\"γ_residual\"),\n",
    "            ],\n",
    "            axis=1,\n",
    "        ),\n",
    "        y=returns,\n",
    "        dropna=False,\n",
    "    ),\n",
    "    axis=1,\n",
    ")\n",
    "γ_pure_factor_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## B - Check for each factor their historical returns are significant or not (based on T-stat)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 10;\n",
       "                var nbb_unformatted_code = \"T = \\u03b3_pure_factor_monthly_returns.shape[0]\\n\\n\\u03b3_pure_factor_risk_premium = \\u03b3_pure_factor_monthly_returns.mean(axis=0)\\n\\n\\u03b3_pure_factor_standard_error = \\u03b3_pure_factor_monthly_returns.std(axis=0) / np.sqrt(T)\\n\\nt_statistic = \\u03b3_pure_factor_risk_premium / \\u03b3_pure_factor_standard_error\";\n",
       "                var nbb_formatted_code = \"T = \\u03b3_pure_factor_monthly_returns.shape[0]\\n\\n\\u03b3_pure_factor_risk_premium = \\u03b3_pure_factor_monthly_returns.mean(axis=0)\\n\\n\\u03b3_pure_factor_standard_error = \\u03b3_pure_factor_monthly_returns.std(axis=0) / np.sqrt(T)\\n\\nt_statistic = \\u03b3_pure_factor_risk_premium / \\u03b3_pure_factor_standard_error\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "T = γ_pure_factor_monthly_returns.shape[0]\n",
    "\n",
    "γ_pure_factor_risk_premium = γ_pure_factor_monthly_returns.mean(axis=0)\n",
    "\n",
    "γ_pure_factor_standard_error = γ_pure_factor_monthly_returns.std(axis=0) / np.sqrt(T)\n",
    "\n",
    "t_statistic = γ_pure_factor_risk_premium / γ_pure_factor_standard_error"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 11;\n",
       "                var nbb_unformatted_code = \"# One-sample t-test, df = n - 1\\np = 1 - sp.stats.t.cdf(t_statistic, df=T - 1)\";\n",
       "                var nbb_formatted_code = \"# One-sample t-test, df = n - 1\\np = 1 - sp.stats.t.cdf(t_statistic, df=T - 1)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "# One-sample t-test, df = n - 1\n",
    "p = 1 - sp.stats.t.cdf(t_statistic, df=T - 1)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "β (equity market factor exposure) monthly risk premium is not statistically significant.\n",
      "β (us dollar factor exposure) monthly risk premium is not statistically significant.\n",
      "SECTOR_DSCR monthly risk premium is not statistically significant.\n",
      "SECTOR_ENER monthly risk premium is not statistically significant.\n",
      "SECTOR_FINA monthly risk premium is not statistically significant.\n",
      "SECTOR_HLTH monthly risk premium is not statistically significant.\n",
      "SECTOR_INDU monthly risk premium is not statistically significant.\n",
      "SECTOR_INFT monthly risk premium is not statistically significant.\n",
      "SECTOR_MATS monthly risk premium is not statistically significant.\n",
      "SECTOR_REAL monthly risk premium is not statistically significant.\n",
      "SECTOR_STPL monthly risk premium is not statistically significant.\n",
      "SECTOR_TCOM monthly risk premium is not statistically significant.\n",
      "β (size factor exposure) monthly risk premium is statistically significant.\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 12;\n",
       "                var nbb_unformatted_code = \"\\u03b1 = 0.95 # Confidence level\\nfor pure_factor, p_val in zip(\\u03b3_pure_factor_risk_premium.index[:-1], p[:-1]):\\n    if p_val < 1 - \\u03b1:\\n        print(f\\\"{pure_factor} monthly risk premium is statistically significant.\\\")\\n    else:\\n        print(f\\\"{pure_factor} monthly risk premium is not statistically significant.\\\")\";\n",
       "                var nbb_formatted_code = \"\\u03b1 = 0.95  # Confidence level\\nfor pure_factor, p_val in zip(\\u03b3_pure_factor_risk_premium.index[:-1], p[:-1]):\\n    if p_val < 1 - \\u03b1:\\n        print(f\\\"{pure_factor} monthly risk premium is statistically significant.\\\")\\n    else:\\n        print(f\\\"{pure_factor} monthly risk premium is not statistically significant.\\\")\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "α = 0.95  # Confidence level\n",
    "for pure_factor, p_val in zip(γ_pure_factor_risk_premium.index[:-1], p[:-1]):\n",
    "    if p_val < 1 - α:\n",
    "        print(f\"{pure_factor} monthly risk premium is statistically significant.\")\n",
    "    else:\n",
    "        print(f\"{pure_factor} monthly risk premium is not statistically significant.\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## C - Using the last month in the back-test, i.e., 12/31/2018, show"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### 1. All factor portfolios are long-short neutral portfolio, i.e., the total weights sum to 0\t"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 13;\n",
       "                var nbb_unformatted_code = \"X = pd.concat(\\n    [\\n        factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n        sector_factor,\\n        size_factor,\\n        pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n    ],\\n    axis=1,\\n)\\ny = equity_monthly_returns.loc[\\\"2018-12-31\\\"]\\npure_factor_portfolio_weights = np.linalg.inv(X.T @ X) @ X.T\\npure_factor_portfolio_weights.index = X.columns\";\n",
       "                var nbb_formatted_code = \"X = pd.concat(\\n    [\\n        factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n        sector_factor,\\n        size_factor,\\n        pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n    ],\\n    axis=1,\\n)\\ny = equity_monthly_returns.loc[\\\"2018-12-31\\\"]\\npure_factor_portfolio_weights = np.linalg.inv(X.T @ X) @ X.T\\npure_factor_portfolio_weights.index = X.columns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "X = pd.concat(\n",
    "    [\n",
    "        factor_exposures.drop([\"α\"], axis=1),\n",
    "        sector_factor,\n",
    "        size_factor,\n",
    "        pd.Series(1, index=size_factor.index, name=\"γ_residual\"),\n",
    "    ],\n",
    "    axis=1,\n",
    ")\n",
    "y = equity_monthly_returns.loc[\"2018-12-31\"]\n",
    "pure_factor_portfolio_weights = np.linalg.inv(X.T @ X) @ X.T\n",
    "pure_factor_portfolio_weights.index = X.columns"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Check that the allocation of portfolio weights for each stock sums to 0 for all pure factor portfolios"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "True"
      ]
     },
     "execution_count": 14,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 14;\n",
       "                var nbb_unformatted_code = \"# Exclude \\u03b3_residual\\nnp.allclose(pure_factor_portfolio_weights.sum(axis=1)[:-1], 0)\";\n",
       "                var nbb_formatted_code = \"# Exclude \\u03b3_residual\\nnp.allclose(pure_factor_portfolio_weights.sum(axis=1)[:-1], 0)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "# Exclude γ_residual\n",
    "np.allclose(pure_factor_portfolio_weights.sum(axis=1)[:-1], 0)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### 2. For any factor portfolio, it has unit exposure to its own factor, but zero exposure to all other factors in the model"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 15,
   "metadata": {
    "scrolled": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "=======================================\n",
      "|| β (equity market factor exposure) ||\n",
      "=======================================\n",
      "β (equity market factor exposure) has unit exposure to its own factor β (equity market factor exposure) - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (equity market factor exposure) has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "===================================\n",
      "|| β (us dollar factor exposure) ||\n",
      "===================================\n",
      "β (us dollar factor exposure) has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has unit exposure to its own factor β (us dollar factor exposure) - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (us dollar factor exposure) has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_DSCR ||\n",
      "=================\n",
      "SECTOR_DSCR has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has unit exposure to its own factor SECTOR_DSCR - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_DSCR has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_ENER ||\n",
      "=================\n",
      "SECTOR_ENER has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has unit exposure to its own factor SECTOR_ENER - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_ENER has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_FINA ||\n",
      "=================\n",
      "SECTOR_FINA has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has unit exposure to its own factor SECTOR_FINA - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_FINA has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_HLTH ||\n",
      "=================\n",
      "SECTOR_HLTH has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has unit exposure to its own factor SECTOR_HLTH - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_HLTH has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_INDU ||\n",
      "=================\n",
      "SECTOR_INDU has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has unit exposure to its own factor SECTOR_INDU - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INDU has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_INFT ||\n",
      "=================\n",
      "SECTOR_INFT has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has unit exposure to its own factor SECTOR_INFT - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_INFT has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_MATS ||\n",
      "=================\n",
      "SECTOR_MATS has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has unit exposure to its own factor SECTOR_MATS - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_MATS has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_REAL ||\n",
      "=================\n",
      "SECTOR_REAL has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has unit exposure to its own factor SECTOR_REAL - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_REAL has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_STPL ||\n",
      "=================\n",
      "SECTOR_STPL has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has unit exposure to its own factor SECTOR_STPL - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_STPL has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "=================\n",
      "|| SECTOR_TCOM ||\n",
      "=================\n",
      "SECTOR_TCOM has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has unit exposure to its own factor SECTOR_TCOM - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to β (size factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "SECTOR_TCOM has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n",
      "==============================\n",
      "|| β (size factor exposure) ||\n",
      "==============================\n",
      "β (size factor exposure) has 0 exposure to β (equity market factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to β (us dollar factor exposure) factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_DSCR factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_ENER factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_FINA factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_HLTH factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_INDU factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_INFT factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_MATS factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_REAL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_STPL factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to SECTOR_TCOM factor - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has unit exposure to its own factor β (size factor exposure) - factor portfolio weights * stock exposure to factor == 1\n",
      "β (size factor exposure) has 0 exposure to γ_residual factor - factor portfolio weights * stock exposure to factor == 1\n",
      "\n",
      "\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 15;\n",
       "                var nbb_unformatted_code = \"for pure_factor in X.columns[:-1]:\\n    stock_exposures_to_pure_factors = X[pure_factor]\\n    title = \\\"|| \\\" + pure_factor + \\\" ||\\\"\\n    print(\\\"=\\\" * len(title))\\n    print(title)\\n    print(\\\"=\\\" * len(title))\\n    for (\\n        name,\\n        pure_factor_portfolio_weights_for_one_factor,\\n    ) in pure_factor_portfolio_weights.iterrows():\\n        if (\\n            np.allclose(\\n                stock_exposures_to_pure_factors.T\\n                @ pure_factor_portfolio_weights_for_one_factor,\\n                1,\\n            )\\n            and name == pure_factor\\n        ):\\n            print(\\n                f\\\"{pure_factor} has unit exposure to its own factor {name} - factor portfolio weights * stock exposure to factor == 1\\\"\\n            )\\n        elif (\\n            np.allclose(\\n                stock_exposures_to_pure_factors.T\\n                @ pure_factor_portfolio_weights_for_one_factor,\\n                0,\\n            )\\n            and name != pure_factor\\n        ):\\n            print(\\n                f\\\"{pure_factor} has 0 exposure to {name} factor - factor portfolio weights * stock exposure to factor == 1\\\"\\n            )\\n        else:\\n            print(\\\"Something's wrong\\\")\\n    print(\\\"\\\\n\\\")\";\n",
       "                var nbb_formatted_code = \"for pure_factor in X.columns[:-1]:\\n    stock_exposures_to_pure_factors = X[pure_factor]\\n    title = \\\"|| \\\" + pure_factor + \\\" ||\\\"\\n    print(\\\"=\\\" * len(title))\\n    print(title)\\n    print(\\\"=\\\" * len(title))\\n    for (\\n        name,\\n        pure_factor_portfolio_weights_for_one_factor,\\n    ) in pure_factor_portfolio_weights.iterrows():\\n        if (\\n            np.allclose(\\n                stock_exposures_to_pure_factors.T\\n                @ pure_factor_portfolio_weights_for_one_factor,\\n                1,\\n            )\\n            and name == pure_factor\\n        ):\\n            print(\\n                f\\\"{pure_factor} has unit exposure to its own factor {name} - factor portfolio weights * stock exposure to factor == 1\\\"\\n            )\\n        elif (\\n            np.allclose(\\n                stock_exposures_to_pure_factors.T\\n                @ pure_factor_portfolio_weights_for_one_factor,\\n                0,\\n            )\\n            and name != pure_factor\\n        ):\\n            print(\\n                f\\\"{pure_factor} has 0 exposure to {name} factor - factor portfolio weights * stock exposure to factor == 1\\\"\\n            )\\n        else:\\n            print(\\\"Something's wrong\\\")\\n    print(\\\"\\\\n\\\")\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "for pure_factor in X.columns[:-1]:\n",
    "    stock_exposures_to_pure_factors = X[pure_factor]\n",
    "    title = \"|| \" + pure_factor + \" ||\"\n",
    "    print(\"=\" * len(title))\n",
    "    print(title)\n",
    "    print(\"=\" * len(title))\n",
    "    for (\n",
    "        name,\n",
    "        pure_factor_portfolio_weights_for_one_factor,\n",
    "    ) in pure_factor_portfolio_weights.iterrows():\n",
    "        if (\n",
    "            np.allclose(\n",
    "                stock_exposures_to_pure_factors.T\n",
    "                @ pure_factor_portfolio_weights_for_one_factor,\n",
    "                1,\n",
    "            )\n",
    "            and name == pure_factor\n",
    "        ):\n",
    "            print(\n",
    "                f\"{pure_factor} has unit exposure to its own factor {name} - factor portfolio weights * stock exposure to factor == 1\"\n",
    "            )\n",
    "        elif (\n",
    "            np.allclose(\n",
    "                stock_exposures_to_pure_factors.T\n",
    "                @ pure_factor_portfolio_weights_for_one_factor,\n",
    "                0,\n",
    "            )\n",
    "            and name != pure_factor\n",
    "        ):\n",
    "            print(\n",
    "                f\"{pure_factor} has 0 exposure to {name} factor - factor portfolio weights * stock exposure to factor == 1\"\n",
    "            )\n",
    "        else:\n",
    "            print(\"Something's wrong\")\n",
    "    print(\"\\n\")"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.5"
  },
  "latex_envs": {
   "LaTeX_envs_menu_present": true,
   "autoclose": false,
   "autocomplete": true,
   "bibliofile": "biblio.bib",
   "cite_by": "apalike",
   "current_citInitial": 1,
   "eqLabelWithNumbers": true,
   "eqNumInitial": 1,
   "hotkeys": {
    "equation": "Ctrl-E",
    "itemize": "Ctrl-I"
   },
   "labels_anchors": false,
   "latex_user_defs": false,
   "report_style_numbering": false,
   "user_envs_cfg": false
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
